      PROGRAM ALFA
      CHARACTER NAME*80
      COMMON/CHARCM/NAME
      COMMON/CMMN1 / MAX ,TOTINT(9000)
      COMMON/CMMN2 / MAX2, A1INT(9000)

      READ(5,20) NAME
 20   FORMAT(1A80)
      READ(5,*,ERR=1000) THMIN,THMAX,STEPW,ALFA1,ALFA2
      DLOL= (2*ALFA1+ALFA2)/3.
      REFLIN= THMIN-100.*STEPW
      QLABDA=0.99752135
      FRNL=.5
      MAX=(THMAX-THMIN)/STEPW+151.5
      MAX2=MAX
 10   READ (5,*,END=99) (TOTINT(I),I=151,MAX)
 99   CALL RACHCR(STEPW,REFLIN,QLABDA,FRNL,DLOL)
      DO 40 I=151,MAX
      IF (A1INT(I).LT.0.0) A1INT(I)=0.0
 40   CONTINUE
      WRITE(34,30) (A1INT(I),I=151,MAX)
 30   FORMAT(8F8.0)
      GOTO 1100
 1000 PRINT*
      PRINT*,' ERROR IN THE SECOND LINE OF INPUT'
      PRINT*,' IT SHOULD BE: THMIN,THMAX,STEP,ALPHA1,ALPHA2'
      GOTO 1100
 1100 STOP
      END

      SUBROUTINE RACHCR(STEPW,REFLIN,QLABDA,FRNL,DLOL)
C  THE RACHINGER CORRECTION REMOVES THE ALPHA2 PART OF THE MEASURED SIGNAL.
C  THE MEASURED DATA ARE AVAILABLE IN  FUNC1, (HERE NAMED TOTINT)
C  THE CORRECTED DATA ARE WRITTEN ONTO FUNC2, (HERE NAMED  A1INT).
      CHARACTER NAME*80
      COMMON/CHARCM/NAME
      COMMON/CMMN1 / MAX ,TOTINT(9000)
      COMMON/CMMN2 / MAX2, A1INT(9000)
      CHARACTER*1 BLANK,PLUS,STAR,LINE(120)
      DATA BLANK/' '/,STAR/'*'/,PLUS/'+'/
C  WE HAVE ADDED 150 ARTIFICIAL DATA,50 OF WHICH ARE BEFORE THE ARTIFICIAL
C  REFERENCE LINE. THE TWOTHETA CAN BE CALCULATED BY  (K=NUMBER OF ARRAY-EL)
C     TWOTHET=(K-51)*STEPW + REFLIN, OR (REFCOR=REFLIN-51*STEPW)
C     TWOTHET= K*STEPW + REFCOR
C
      TETRAD(K)=(K*STEPW+REFCOR)*RRAD
      ALFSEP(T)=T-ASIN( SIN(T)*QLABDA )
C
      RAD=45./ATAN(1.)
      RRAD=0.5/RAD
      REFCOR=REFLIN-51*STEPW
C--------------------------------------------
      DO 70 I=151,9000
   70 A1INT(I)=.0
      STPRAD=STEPW*RRAD
      ISTART=151
      NSTART=ISTART
C THE ALPHA2-STRIPPING CAN ONLY START WHEN THE ALPHA1-ALPHA2 SEPARATION
C IS LARGER THAN THE STEPWIDTH. CHECK THIS.
      A=TETRAD(ISTART)
      B=ALFSEP(A)
      IF (B .LT. STPRAD) THEN
         TETBEG=ATAN(STPRAD/DLOL)*2.*RAD+1.0
         NSTART=(TETBEG-REFLIN)/STEPW+51
         NSTART=10*(NSTART/10 +1)
         A=TETRAD(NSTART)
         B=ALFSEP(A)
      END IF
      NB=NINT(B/STPRAD)
C
      IF (NSTART .EQ. ISTART) THEN
C WE MUST START THE A2-STRIPPING AT A POINT WHERE THERE IS ALREADY
C A SIGNIFICANT A1-A2 SPLITTING.
C WE HOPE TO FIND SOMETHING LIKE A BACKGROUND TO START WITH,
C IF IT IS IN A PEAK, THE FIRST PART OF THE A2-STRIPPING WILL HAVE
C A SIGNIFICANT ERROR. THIS ERROR WILL SOON BE REDUCED TO ZERO.
         HMIN=1000.
         DO 80 J=ISTART,ISTART + 10
            IF (TOTINT(J) .GT. HMIN) GO TO 80
            HMIN=TOTINT(J)
            K=J
   80    CONTINUE
         IF ( (K .EQ. ISTART+10) .OR. (K .EQ. ISTART) ) THEN
            BCKGR=HMIN
         ELSE
            BCKGR=(TOTINT(K-1)+HMIN+TOTINT(K+1))/3.
         ENDIF
         A2=BCKGR*FRNL/(1.+FRNL)
         DO 90 I=NSTART,NSTART+NB
   90       A1INT(I)=TOTINT(I)-A2
         NSTART=NSTART+NB
      ELSE
C ---------------------------------------------------------
C  BETWEEN ISTART AND NSTART THE A1-A2 SEPARATION IS LESS THAN THE
C  STEPWIDTH. WE ASSUME THAT THE A1-PART IS F=1.0/(1.0+FRNL) TIMES THE
C  MEASURED INTENSITY (FRNL = ABT 0.5 , F= ABT. 2/3 ).
C
         F=1.0/(1.0+FRNL)
         DO 100 I=ISTART,NSTART
  100    A1INT(I)=F*TOTINT(I)
      END IF
C  THE 'RACHINGER CORRECTION CAN START NOW.
C-------------------------------------------------------------------
      N20=(MAX-NSTART)/20
      M1=NSTART
      A1=TETRAD(M1)
      ASEP1=ALFSEP(A1)
      DO 300 NN=1,N20
         A20=TETRAD(M1+20)
         ASEP20=ALFSEP(A20)
         DELTA=(ASEP20-ASEP1)/20.
         DO 200 I=1,20
            ASEP=ASEP1+I*DELTA
            FN=ASEP/STPRAD
            N=INT(FN)
            MN=M1+I-N
            A1P=A1INT(MN)+(FN-N)*(A1INT(MN-1)-A1INT(MN) )
            A1INT(M1+I)=TOTINT(M1+I)-FRNL*A1P
  200    CONTINUE
         M1=M1+20
         ASEP1=ASEP20
  300 CONTINUE
      MAX2=M1-20
C-----------------------------------------------------------------
      DO 410 I=1,120
      LINE(I)=BLANK
  410 CONTINUE
      DO 450 I=150, 200
         TWOTHT=I*STEPW+REFCOR
         J=NINT(A1INT(I) )
         IF (J .LT. 1) J=1
         LINE(J)=STAR
         K=NINT(TOTINT(I) )
         IF (K .LT. 1) K=1
         LINE(K)=PLUS
         L=MAX0(J,K)
         LINE(J)=BLANK
         LINE(K)=BLANK
  450 CONTINUE
      RETURN
      END
